# remirepo/Fedora spec file for php-zendframework-zend-mvc-console
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    821c18e0d57e71b370166bd2f35623befddaf2ee
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-mvc-console
%global php_home     %{_datadir}/php
%global library      Console
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.2.0
Release:        3%{?dist}
Summary:        Zend Framework Mvc-%{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "squizlabs/php_codesniffer": "^2.3.1",
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-filter": "^2.6.1"
BuildRequires: (php-composer(container-interop/container-interop) >= 1.1   with php-composer(container-interop/container-interop) < 2)
BuildRequires: (php-autoloader(%{gh_owner}/zend-console)          >= 2.6   with php-autoloader(%{gh_owner}/zend-console)          < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-eventmanager)     >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)     < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-modulemanager)    >= 2.7.1 with php-autoloader(%{gh_owner}/zend-modulemanager)    < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0.3 with php-autoloader(%{gh_owner}/zend-mvc)              < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-router)           >= 3.0   with php-autoloader(%{gh_owner}/zend-router)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager)   >= 2.7.5 with php-autoloader(%{gh_owner}/zend-servicemanager)   < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7.5 with php-autoloader(%{gh_owner}/zend-stdlib)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-text)             >= 2.6   with php-autoloader(%{gh_owner}/zend-text)             < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-view)             >= 2.6.3 with php-autoloader(%{gh_owner}/zend-view)             < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-filter)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-filter)           < 3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "container-interop/container-interop": "^1.1",
#        "zendframework/zend-console": "^2.6",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-modulemanager": "^2.7.1",
#        "zendframework/zend-mvc": "^3.0.3",
#        "zendframework/zend-router": "^3.0",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-stdlib": "^2.7.5 || ^3.0",
#        "zendframework/zend-text": "^2.6",
#        "zendframework/zend-view": "^2.6.3"
Requires:       php(language) >= 5.6
Requires:      (php-composer(container-interop/container-interop) >= 1.1   with php-composer(container-interop/container-interop) < 2)
Requires:      (php-autoloader(%{gh_owner}/zend-console)          >= 2.6   with php-autoloader(%{gh_owner}/zend-console)          < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-eventmanager)     >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)     < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-modulemanager)    >= 2.7.1 with php-autoloader(%{gh_owner}/zend-modulemanager)    < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0.3 with php-autoloader(%{gh_owner}/zend-mvc)              < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-router)           >= 3.0   with php-autoloader(%{gh_owner}/zend-router)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-servicemanager)   >= 2.7.5 with php-autoloader(%{gh_owner}/zend-servicemanager)   < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7.5 with php-autoloader(%{gh_owner}/zend-stdlib)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-text)             >= 2.6   with php-autoloader(%{gh_owner}/zend-text)             < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-view)             >= 2.6.3 with php-autoloader(%{gh_owner}/zend-view)             < 3)
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.1.10
Requires:       php-spl
%if ! %{bootstrap}
# From composer, "suggest": {
#        "zendframework/zend-filter": "^2.6.1, to filter rendered results"
Suggests:       php-composer(%{gh_owner}/zend-filter)
%endif

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
zend-mvc-console provides integration between:

* zend-console
* zend-mvc
* zend-router
* zend-view

and replaces the console functionality found in the v2 releases of the latter
three components.

* File issues at https://github.com/zendframework/zend-mvc-console/issues
* Documentation is at https://zendframework.github.io/zend-mvc-console/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
require_once '%{php_home}/Interop/Container/autoload.php';
EOF

: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Interop/Container/autoload.php',
    '%{php_home}/Zend/Console/autoload.php',
    '%{php_home}/Zend/EventManager/autoload.php',
    '%{php_home}/Zend/ModuleManager/autoload.php',
    '%{php_home}/Zend/Mvc/autoload.php',
    '%{php_home}/Zend/Router/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Text/autoload.php',
    '%{php_home}/Zend/View/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Filter/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/Mvc
cp -pr src %{buildroot}%{php_home}/Zend/Mvc/%{library}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/Mvc-%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/Mvc/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\Mvc\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/Mvc/%{library}
%{php_home}/Zend/Mvc-%{library}-autoload.php


%changelog
* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 1.2.0-1
- update to 1.2.0
- use range dependencies
- switch to phpunit7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.11-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 1.1.11-4
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.11-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.11-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Dec 15 2016 Remi Collet <remi@fedoraproject.org> - 1.1.11-1
- update to 1.1.11
- raise dependency on zendframework/zend-mvc 3.0.3

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 1.1.10-1
- initial package

